'******************************************************************************
'*  pm80_demo.spin - a demo mode for the PM80 core
'*
'*  (c) Juergen Buchmueller <pullmoll@t-online.de>
'*
'* $Id: pm80_demo.spin,v 1.14 2010-03-09 05:31:19 pm Exp $
'******************************************************************************
CON
	_xinfreq		= 5_000_000		' Quartz is 5MHz
	_clkmode		= xtal1 + pll16x	' System clock is 80MHz

OBJ
        pm80  : "pm80"
VAR
	byte memory[1024]
	byte io[256]
        long pc
PUB     main : okay

        pc := 0
        memory[pc++] := $31	' ld sp, 1024
        memory[pc++] := $00
        memory[pc++] := $04
        memory[pc++] := $c3	' jp 100h
        memory[pc++] := $00
        memory[pc++] := $01
	pc := $38
        memory[pc++] := $d3	' out ($40), a
        memory[pc++] := $40
        memory[pc++] := $c9	' ret

	pc := $100
        memory[pc++] := $21	' ld hl, 180h
        memory[pc++] := $80
        memory[pc++] := $01
        memory[pc++] := $7e	' ld a, (hl)
        memory[pc++] := $fe	' cp $24
        memory[pc++] := $24
        memory[pc++] := $ca	' jp z, $100
        memory[pc++] := $00
        memory[pc++] := $01
        memory[pc++] := $ff	' rst 38h
        memory[pc++] := $23	' inc hl
	memory[pc++] := $c3	' jp 103h
	memory[pc++] := $03
	memory[pc++] := $01

	pc := $180
	memory[pc++] := "H"
	memory[pc++] := "e"
	memory[pc++] := "l"
	memory[pc++] := "l"
	memory[pc++] := "o"
	memory[pc++] := " "
	memory[pc++] := "w"
	memory[pc++] := "o"
	memory[pc++] := "r"
	memory[pc++] := "l"
	memory[pc++] := "d"
	memory[pc++] := "!"
	memory[pc++] := 13
	memory[pc++] := "$"

        pm80.start(@memory, @io)
